package reborncore.client.gui;

import net.minecraft.client.gui.inventory.GuiContainer;
import net.minecraft.inventory.Container;
import net.minecraft.inventory.Slot;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.ResourceLocation;
import reborncore.api.gui.IGuiComponent;
import reborncore.client.gui.componets.BaseTextures;

import java.util.ArrayList;
import java.util.List;

public class BaseGui extends GuiContainer {

    Container container;

    TileEntity tileEntity;

    List<IGuiComponent> componentList;

    BaseTextures baseTextures;

    private static final ResourceLocation baseTexture = new ResourceLocation(
            "reborncore", "textures/gui/base.png");

    public BaseGui(Container container, TileEntity tileEntity) {
        super(container);
        this.container = container;
        this.tileEntity = tileEntity;
        componentList = new ArrayList<IGuiComponent>();
        registerComponets();
        baseTextures = new BaseTextures();
    }

    @Override
    protected void func_146976_a(float p_146976_1_, int p_146976_2_, int p_146976_3_) {
        this.field_146297_k.field_71446_o.func_110577_a(baseTexture);
        int x = (this.field_146294_l - this.field_146999_f) / 2;
        int y = (this.field_146295_m - this.field_147000_g) / 2;

        baseTextures.background.draw(0, 0, this);

        for(Object slotObj : container.field_75151_b){
            if(slotObj instanceof Slot){
                Slot slot = (Slot) slotObj;
                baseTextures.slot.draw(slot.field_75223_e  -1, slot.field_75221_f -1, this);
            }
        }

        for(IGuiComponent component : componentList){
            component.drawGuiContainerBackgroundLayer(this);
        }
    }

    public Container getContainer() {
        return container;
    }

    public TileEntity getTileEntity() {
        return tileEntity;
    }

    /**
     * Override this and add components in here.
     */
    public void registerComponets(){

    }

    public void registerComponet(IGuiComponent component){
        componentList.add(component);
    }

    @Override
    public void func_73866_w_() {
        super.func_73866_w_();
        for(IGuiComponent component : componentList){
            component.initGui(this);
        }
    }

    @Override
    public void func_73863_a(int p_73863_1_, int p_73863_2_, float p_73863_3_) {
        super.func_73863_a(p_73863_1_, p_73863_2_, p_73863_3_);
        for(IGuiComponent component : componentList){
            component.drawScreen(this);
        }
    }

    @Override
    protected void func_146979_b(int p_146979_1_, int p_146979_2_) {
        super.func_146979_b(p_146979_1_, p_146979_2_);
        for(IGuiComponent component : componentList){
            component.drawGuiContainerBackgroundLayer(this);
        }
    }

    @Override
    public void func_146281_b() {
        super.func_146281_b();
        for(IGuiComponent component : componentList){
            component.onGuiClosed(this);
        }
    }

    @Override
    public void func_73876_c() {
        super.func_73876_c();
        for(IGuiComponent component : componentList){
            component.updateScreen(this);
        }
    }

    public BaseTextures getBaseTextures() {
        return baseTextures;
    }

    public int getXSize(){
        return field_146999_f;
    }

    public int getYSize(){
        return field_147000_g;
    }

}
